## Exercise 1 -- Hit Counter 2

Consider the `hit-counter2` directory
- this is a Node project working exactly as `hit-counter` from example 2
- except it assumes a MongoDB instance to be in place to keep track of how many requests have been served so far, in total
- in this way the service can be replicated many times, without affecting the count presented to the user
- for this reason, the service assumes a number of _environment_ variables to be set, namely:
    +`MONGO_HOST` is a string identifying host name of the machine hosting MongoDB
    + `MONGO_PORT` is a number identifying the port MongoDB is listening on
    + `MONGO_USER` is the user identifier the service will exploit to interact with MongoDB 
    + `MONGO_PASSWORD` is the password corresponding to the MongoDB user above

MongoDB instances can be started up with Docker, via ad-hoc images:
- [`mongodb`](https://hub.docker.com/_/mongo) the actual No-SQL DBMS
- [`mongo-express`](https://hub.docker.com/_/mongo-express) a Web-based dashboard for MongoDB instances

> Once completed, the provided `docker-compose.yaml` file should be able to start a MongoDB instance via either Docker Compose or Swarm 


Locally you may try the server by:
1. Running `npm install` to restore NPM dependencies (this is to be run just __once__)
2. Starting a MongoDB instance on `localhost:27017`, using `admin` as __both username and passoword__
3. Running`npm start` to start the service on `localhost:8080`

Once the service is running, you may query it by either:
- browsing to http://localhost:8080 in your browser
- run `curl http://localhost:8080`
- run the `poll-localhost.sh` script as follows:
    ```bash
    ../poll-localhost.sh 8080
    ```

> __Goal__: complete the `docker-compose.yaml` file in such a way that it starts 
> - 1 MongoDB instance
> - 1 Dashboard instance
> - N &gt; 1 instances of Hit Counter 2

#### Steps

1. Dockerify `hit-counter2`, creating an image named `<your DockerHub account>/hit-counter2`

2. Complete the `docker-compose.yaml` file in such a way that it starts 
- 1 MongoDB instance
- 1 Dashboard instance
- N &gt; 1 instances of Hit Counter 2

3. Create the `hit-counter2` stack via Docker __Swarm__

4. Run the `poll-localhost.sh` script to demonstrate that 
    - N instances of Hit Counter 2 are actually running
    - the count provided by the Hit Counter 2 instances are actually cumulative, regardless of which and how many instances are serving your requests

5. Create a `SOLUTION.md` file discussing your solution, and arguing about its correctness
    + including snippets of the logs generated by the aforementioned commands is admissible 

